/*
SpaceTraders API

SpaceTraders is an open-universe game and learning platform that offers a set of HTTP endpoints to control a fleet of ships and explore a multiplayer universe.  The API is documented using [OpenAPI](https://github.com/SpaceTradersAPI/api-docs). You can send your first request right here in your browser to check the status of the game server.  ```json http {   \"method\": \"GET\",   \"url\": \"https://api.spacetraders.io/v2\", } ```  Unlike a traditional game, SpaceTraders does not have a first-party client or app to play the game. Instead, you can use the API to build your own client, write a script to automate your ships, or try an app built by the community.  We have a [Discord channel](https://discord.com/invite/jh6zurdWk5) where you can share your projects, ask questions, and get help from other players.   

API version: 2.0.0
Contact: joel@spacetraders.io
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package spacetraders

import (
	"encoding/json"
)

// checks if the CreateShipShipScan201ResponseData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateShipShipScan201ResponseData{}

// CreateShipShipScan201ResponseData struct for CreateShipShipScan201ResponseData
type CreateShipShipScan201ResponseData struct {
	Cooldown Cooldown `json:"cooldown"`
	Ships []ScannedShip `json:"ships"`
	AdditionalProperties map[string]interface{}
}

type _CreateShipShipScan201ResponseData CreateShipShipScan201ResponseData

// NewCreateShipShipScan201ResponseData instantiates a new CreateShipShipScan201ResponseData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateShipShipScan201ResponseData(cooldown Cooldown, ships []ScannedShip) *CreateShipShipScan201ResponseData {
	this := CreateShipShipScan201ResponseData{}
	this.Cooldown = cooldown
	this.Ships = ships
	return &this
}

// NewCreateShipShipScan201ResponseDataWithDefaults instantiates a new CreateShipShipScan201ResponseData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateShipShipScan201ResponseDataWithDefaults() *CreateShipShipScan201ResponseData {
	this := CreateShipShipScan201ResponseData{}
	return &this
}

// GetCooldown returns the Cooldown field value
func (o *CreateShipShipScan201ResponseData) GetCooldown() Cooldown {
	if o == nil {
		var ret Cooldown
		return ret
	}

	return o.Cooldown
}

// GetCooldownOk returns a tuple with the Cooldown field value
// and a boolean to check if the value has been set.
func (o *CreateShipShipScan201ResponseData) GetCooldownOk() (*Cooldown, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Cooldown, true
}

// SetCooldown sets field value
func (o *CreateShipShipScan201ResponseData) SetCooldown(v Cooldown) {
	o.Cooldown = v
}

// GetShips returns the Ships field value
func (o *CreateShipShipScan201ResponseData) GetShips() []ScannedShip {
	if o == nil {
		var ret []ScannedShip
		return ret
	}

	return o.Ships
}

// GetShipsOk returns a tuple with the Ships field value
// and a boolean to check if the value has been set.
func (o *CreateShipShipScan201ResponseData) GetShipsOk() ([]ScannedShip, bool) {
	if o == nil {
		return nil, false
	}
	return o.Ships, true
}

// SetShips sets field value
func (o *CreateShipShipScan201ResponseData) SetShips(v []ScannedShip) {
	o.Ships = v
}

func (o CreateShipShipScan201ResponseData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateShipShipScan201ResponseData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["cooldown"] = o.Cooldown
	toSerialize["ships"] = o.Ships

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *CreateShipShipScan201ResponseData) UnmarshalJSON(bytes []byte) (err error) {
	varCreateShipShipScan201ResponseData := _CreateShipShipScan201ResponseData{}

	if err = json.Unmarshal(bytes, &varCreateShipShipScan201ResponseData); err == nil {
		*o = CreateShipShipScan201ResponseData(varCreateShipShipScan201ResponseData)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "cooldown")
		delete(additionalProperties, "ships")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableCreateShipShipScan201ResponseData struct {
	value *CreateShipShipScan201ResponseData
	isSet bool
}

func (v NullableCreateShipShipScan201ResponseData) Get() *CreateShipShipScan201ResponseData {
	return v.value
}

func (v *NullableCreateShipShipScan201ResponseData) Set(val *CreateShipShipScan201ResponseData) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateShipShipScan201ResponseData) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateShipShipScan201ResponseData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateShipShipScan201ResponseData(val *CreateShipShipScan201ResponseData) *NullableCreateShipShipScan201ResponseData {
	return &NullableCreateShipShipScan201ResponseData{value: val, isSet: true}
}

func (v NullableCreateShipShipScan201ResponseData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateShipShipScan201ResponseData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


