/*
SpaceTraders API

SpaceTraders is an open-universe game and learning platform that offers a set of HTTP endpoints to control a fleet of ships and explore a multiplayer universe.  The API is documented using [OpenAPI](https://github.com/SpaceTradersAPI/api-docs). You can send your first request right here in your browser to check the status of the game server.  ```json http {   \"method\": \"GET\",   \"url\": \"https://api.spacetraders.io/v2\", } ```  Unlike a traditional game, SpaceTraders does not have a first-party client or app to play the game. Instead, you can use the API to build your own client, write a script to automate your ships, or try an app built by the community.  We have a [Discord channel](https://discord.com/invite/jh6zurdWk5) where you can share your projects, ask questions, and get help from other players.   

API version: 2.0.0
Contact: joel@spacetraders.io
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package spacetraders

import (
	"encoding/json"
)

// checks if the GetJumpGate200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetJumpGate200Response{}

// GetJumpGate200Response 
type GetJumpGate200Response struct {
	Data JumpGate `json:"data"`
	AdditionalProperties map[string]interface{}
}

type _GetJumpGate200Response GetJumpGate200Response

// NewGetJumpGate200Response instantiates a new GetJumpGate200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetJumpGate200Response(data JumpGate) *GetJumpGate200Response {
	this := GetJumpGate200Response{}
	this.Data = data
	return &this
}

// NewGetJumpGate200ResponseWithDefaults instantiates a new GetJumpGate200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetJumpGate200ResponseWithDefaults() *GetJumpGate200Response {
	this := GetJumpGate200Response{}
	return &this
}

// GetData returns the Data field value
func (o *GetJumpGate200Response) GetData() JumpGate {
	if o == nil {
		var ret JumpGate
		return ret
	}

	return o.Data
}

// GetDataOk returns a tuple with the Data field value
// and a boolean to check if the value has been set.
func (o *GetJumpGate200Response) GetDataOk() (*JumpGate, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Data, true
}

// SetData sets field value
func (o *GetJumpGate200Response) SetData(v JumpGate) {
	o.Data = v
}

func (o GetJumpGate200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetJumpGate200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["data"] = o.Data

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *GetJumpGate200Response) UnmarshalJSON(bytes []byte) (err error) {
	varGetJumpGate200Response := _GetJumpGate200Response{}

	if err = json.Unmarshal(bytes, &varGetJumpGate200Response); err == nil {
		*o = GetJumpGate200Response(varGetJumpGate200Response)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "data")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableGetJumpGate200Response struct {
	value *GetJumpGate200Response
	isSet bool
}

func (v NullableGetJumpGate200Response) Get() *GetJumpGate200Response {
	return v.value
}

func (v *NullableGetJumpGate200Response) Set(val *GetJumpGate200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetJumpGate200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetJumpGate200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetJumpGate200Response(val *GetJumpGate200Response) *NullableGetJumpGate200Response {
	return &NullableGetJumpGate200Response{value: val, isSet: true}
}

func (v NullableGetJumpGate200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetJumpGate200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


