/*
SpaceTraders API

SpaceTraders is an open-universe game and learning platform that offers a set of HTTP endpoints to control a fleet of ships and explore a multiplayer universe.  The API is documented using [OpenAPI](https://github.com/SpaceTradersAPI/api-docs). You can send your first request right here in your browser to check the status of the game server.  ```json http {   \"method\": \"GET\",   \"url\": \"https://api.spacetraders.io/v2\", } ```  Unlike a traditional game, SpaceTraders does not have a first-party client or app to play the game. Instead, you can use the API to build your own client, write a script to automate your ships, or try an app built by the community.  We have a [Discord channel](https://discord.com/invite/jh6zurdWk5) where you can share your projects, ask questions, and get help from other players.   

API version: 2.0.0
Contact: joel@spacetraders.io
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package spacetraders

import (
	"encoding/json"
)

// checks if the JumpShipRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JumpShipRequest{}

// JumpShipRequest struct for JumpShipRequest
type JumpShipRequest struct {
	// The system symbol to jump to.
	SystemSymbol string `json:"systemSymbol"`
	AdditionalProperties map[string]interface{}
}

type _JumpShipRequest JumpShipRequest

// NewJumpShipRequest instantiates a new JumpShipRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJumpShipRequest(systemSymbol string) *JumpShipRequest {
	this := JumpShipRequest{}
	this.SystemSymbol = systemSymbol
	return &this
}

// NewJumpShipRequestWithDefaults instantiates a new JumpShipRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJumpShipRequestWithDefaults() *JumpShipRequest {
	this := JumpShipRequest{}
	return &this
}

// GetSystemSymbol returns the SystemSymbol field value
func (o *JumpShipRequest) GetSystemSymbol() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SystemSymbol
}

// GetSystemSymbolOk returns a tuple with the SystemSymbol field value
// and a boolean to check if the value has been set.
func (o *JumpShipRequest) GetSystemSymbolOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SystemSymbol, true
}

// SetSystemSymbol sets field value
func (o *JumpShipRequest) SetSystemSymbol(v string) {
	o.SystemSymbol = v
}

func (o JumpShipRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JumpShipRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["systemSymbol"] = o.SystemSymbol

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *JumpShipRequest) UnmarshalJSON(bytes []byte) (err error) {
	varJumpShipRequest := _JumpShipRequest{}

	if err = json.Unmarshal(bytes, &varJumpShipRequest); err == nil {
		*o = JumpShipRequest(varJumpShipRequest)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "systemSymbol")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableJumpShipRequest struct {
	value *JumpShipRequest
	isSet bool
}

func (v NullableJumpShipRequest) Get() *JumpShipRequest {
	return v.value
}

func (v *NullableJumpShipRequest) Set(val *JumpShipRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableJumpShipRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableJumpShipRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJumpShipRequest(val *JumpShipRequest) *NullableJumpShipRequest {
	return &NullableJumpShipRequest{value: val, isSet: true}
}

func (v NullableJumpShipRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJumpShipRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


