/*
SpaceTraders API

SpaceTraders is an open-universe game and learning platform that offers a set of HTTP endpoints to control a fleet of ships and explore a multiplayer universe.  The API is documented using [OpenAPI](https://github.com/SpaceTradersAPI/api-docs). You can send your first request right here in your browser to check the status of the game server.  ```json http {   \"method\": \"GET\",   \"url\": \"https://api.spacetraders.io/v2\", } ```  Unlike a traditional game, SpaceTraders does not have a first-party client or app to play the game. Instead, you can use the API to build your own client, write a script to automate your ships, or try an app built by the community.  We have a [Discord channel](https://discord.com/invite/jh6zurdWk5) where you can share your projects, ask questions, and get help from other players.   

API version: 2.0.0
Contact: joel@spacetraders.io
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package spacetraders

import (
	"encoding/json"
)

// checks if the PurchaseShip201ResponseData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PurchaseShip201ResponseData{}

// PurchaseShip201ResponseData struct for PurchaseShip201ResponseData
type PurchaseShip201ResponseData struct {
	Agent Agent `json:"agent"`
	Ship Ship `json:"ship"`
	Transaction ShipyardTransaction `json:"transaction"`
	AdditionalProperties map[string]interface{}
}

type _PurchaseShip201ResponseData PurchaseShip201ResponseData

// NewPurchaseShip201ResponseData instantiates a new PurchaseShip201ResponseData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPurchaseShip201ResponseData(agent Agent, ship Ship, transaction ShipyardTransaction) *PurchaseShip201ResponseData {
	this := PurchaseShip201ResponseData{}
	this.Agent = agent
	this.Ship = ship
	this.Transaction = transaction
	return &this
}

// NewPurchaseShip201ResponseDataWithDefaults instantiates a new PurchaseShip201ResponseData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPurchaseShip201ResponseDataWithDefaults() *PurchaseShip201ResponseData {
	this := PurchaseShip201ResponseData{}
	return &this
}

// GetAgent returns the Agent field value
func (o *PurchaseShip201ResponseData) GetAgent() Agent {
	if o == nil {
		var ret Agent
		return ret
	}

	return o.Agent
}

// GetAgentOk returns a tuple with the Agent field value
// and a boolean to check if the value has been set.
func (o *PurchaseShip201ResponseData) GetAgentOk() (*Agent, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Agent, true
}

// SetAgent sets field value
func (o *PurchaseShip201ResponseData) SetAgent(v Agent) {
	o.Agent = v
}

// GetShip returns the Ship field value
func (o *PurchaseShip201ResponseData) GetShip() Ship {
	if o == nil {
		var ret Ship
		return ret
	}

	return o.Ship
}

// GetShipOk returns a tuple with the Ship field value
// and a boolean to check if the value has been set.
func (o *PurchaseShip201ResponseData) GetShipOk() (*Ship, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Ship, true
}

// SetShip sets field value
func (o *PurchaseShip201ResponseData) SetShip(v Ship) {
	o.Ship = v
}

// GetTransaction returns the Transaction field value
func (o *PurchaseShip201ResponseData) GetTransaction() ShipyardTransaction {
	if o == nil {
		var ret ShipyardTransaction
		return ret
	}

	return o.Transaction
}

// GetTransactionOk returns a tuple with the Transaction field value
// and a boolean to check if the value has been set.
func (o *PurchaseShip201ResponseData) GetTransactionOk() (*ShipyardTransaction, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Transaction, true
}

// SetTransaction sets field value
func (o *PurchaseShip201ResponseData) SetTransaction(v ShipyardTransaction) {
	o.Transaction = v
}

func (o PurchaseShip201ResponseData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PurchaseShip201ResponseData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["agent"] = o.Agent
	toSerialize["ship"] = o.Ship
	toSerialize["transaction"] = o.Transaction

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *PurchaseShip201ResponseData) UnmarshalJSON(bytes []byte) (err error) {
	varPurchaseShip201ResponseData := _PurchaseShip201ResponseData{}

	if err = json.Unmarshal(bytes, &varPurchaseShip201ResponseData); err == nil {
		*o = PurchaseShip201ResponseData(varPurchaseShip201ResponseData)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "agent")
		delete(additionalProperties, "ship")
		delete(additionalProperties, "transaction")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullablePurchaseShip201ResponseData struct {
	value *PurchaseShip201ResponseData
	isSet bool
}

func (v NullablePurchaseShip201ResponseData) Get() *PurchaseShip201ResponseData {
	return v.value
}

func (v *NullablePurchaseShip201ResponseData) Set(val *PurchaseShip201ResponseData) {
	v.value = val
	v.isSet = true
}

func (v NullablePurchaseShip201ResponseData) IsSet() bool {
	return v.isSet
}

func (v *NullablePurchaseShip201ResponseData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePurchaseShip201ResponseData(val *PurchaseShip201ResponseData) *NullablePurchaseShip201ResponseData {
	return &NullablePurchaseShip201ResponseData{value: val, isSet: true}
}

func (v NullablePurchaseShip201ResponseData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePurchaseShip201ResponseData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


