/*
SpaceTraders API

SpaceTraders is an open-universe game and learning platform that offers a set of HTTP endpoints to control a fleet of ships and explore a multiplayer universe.  The API is documented using [OpenAPI](https://github.com/SpaceTradersAPI/api-docs). You can send your first request right here in your browser to check the status of the game server.  ```json http {   \"method\": \"GET\",   \"url\": \"https://api.spacetraders.io/v2\", } ```  Unlike a traditional game, SpaceTraders does not have a first-party client or app to play the game. Instead, you can use the API to build your own client, write a script to automate your ships, or try an app built by the community.  We have a [Discord channel](https://discord.com/invite/jh6zurdWk5) where you can share your projects, ask questions, and get help from other players.   

API version: 2.0.0
Contact: joel@spacetraders.io
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package spacetraders

import (
	"encoding/json"
)

// checks if the SellCargoRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SellCargoRequest{}

// SellCargoRequest struct for SellCargoRequest
type SellCargoRequest struct {
	Symbol string `json:"symbol"`
	Units int32 `json:"units"`
	AdditionalProperties map[string]interface{}
}

type _SellCargoRequest SellCargoRequest

// NewSellCargoRequest instantiates a new SellCargoRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSellCargoRequest(symbol string, units int32) *SellCargoRequest {
	this := SellCargoRequest{}
	this.Symbol = symbol
	this.Units = units
	return &this
}

// NewSellCargoRequestWithDefaults instantiates a new SellCargoRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSellCargoRequestWithDefaults() *SellCargoRequest {
	this := SellCargoRequest{}
	return &this
}

// GetSymbol returns the Symbol field value
func (o *SellCargoRequest) GetSymbol() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Symbol
}

// GetSymbolOk returns a tuple with the Symbol field value
// and a boolean to check if the value has been set.
func (o *SellCargoRequest) GetSymbolOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Symbol, true
}

// SetSymbol sets field value
func (o *SellCargoRequest) SetSymbol(v string) {
	o.Symbol = v
}

// GetUnits returns the Units field value
func (o *SellCargoRequest) GetUnits() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Units
}

// GetUnitsOk returns a tuple with the Units field value
// and a boolean to check if the value has been set.
func (o *SellCargoRequest) GetUnitsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Units, true
}

// SetUnits sets field value
func (o *SellCargoRequest) SetUnits(v int32) {
	o.Units = v
}

func (o SellCargoRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SellCargoRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["symbol"] = o.Symbol
	toSerialize["units"] = o.Units

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *SellCargoRequest) UnmarshalJSON(bytes []byte) (err error) {
	varSellCargoRequest := _SellCargoRequest{}

	if err = json.Unmarshal(bytes, &varSellCargoRequest); err == nil {
		*o = SellCargoRequest(varSellCargoRequest)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "symbol")
		delete(additionalProperties, "units")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableSellCargoRequest struct {
	value *SellCargoRequest
	isSet bool
}

func (v NullableSellCargoRequest) Get() *SellCargoRequest {
	return v.value
}

func (v *NullableSellCargoRequest) Set(val *SellCargoRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSellCargoRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSellCargoRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSellCargoRequest(val *SellCargoRequest) *NullableSellCargoRequest {
	return &NullableSellCargoRequest{value: val, isSet: true}
}

func (v NullableSellCargoRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSellCargoRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


