/*
SpaceTraders API

SpaceTraders is an open-universe game and learning platform that offers a set of HTTP endpoints to control a fleet of ships and explore a multiplayer universe.  The API is documented using [OpenAPI](https://github.com/SpaceTradersAPI/api-docs). You can send your first request right here in your browser to check the status of the game server.  ```json http {   \"method\": \"GET\",   \"url\": \"https://api.spacetraders.io/v2\", } ```  Unlike a traditional game, SpaceTraders does not have a first-party client or app to play the game. Instead, you can use the API to build your own client, write a script to automate your ships, or try an app built by the community.  We have a [Discord channel](https://discord.com/invite/jh6zurdWk5) where you can share your projects, ask questions, and get help from other players.   

API version: 2.0.0
Contact: joel@spacetraders.io
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package spacetraders

import (
	"encoding/json"
)

// checks if the ShipCargo type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ShipCargo{}

// ShipCargo struct for ShipCargo
type ShipCargo struct {
	// The max number of items that can be stored in the cargo hold.
	Capacity int32 `json:"capacity"`
	// The number of items currently stored in the cargo hold.
	Units int32 `json:"units"`
	// The items currently in the cargo hold.
	Inventory []ShipCargoItem `json:"inventory"`
	AdditionalProperties map[string]interface{}
}

type _ShipCargo ShipCargo

// NewShipCargo instantiates a new ShipCargo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewShipCargo(capacity int32, units int32, inventory []ShipCargoItem) *ShipCargo {
	this := ShipCargo{}
	this.Capacity = capacity
	this.Units = units
	this.Inventory = inventory
	return &this
}

// NewShipCargoWithDefaults instantiates a new ShipCargo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewShipCargoWithDefaults() *ShipCargo {
	this := ShipCargo{}
	return &this
}

// GetCapacity returns the Capacity field value
func (o *ShipCargo) GetCapacity() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Capacity
}

// GetCapacityOk returns a tuple with the Capacity field value
// and a boolean to check if the value has been set.
func (o *ShipCargo) GetCapacityOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Capacity, true
}

// SetCapacity sets field value
func (o *ShipCargo) SetCapacity(v int32) {
	o.Capacity = v
}

// GetUnits returns the Units field value
func (o *ShipCargo) GetUnits() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Units
}

// GetUnitsOk returns a tuple with the Units field value
// and a boolean to check if the value has been set.
func (o *ShipCargo) GetUnitsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Units, true
}

// SetUnits sets field value
func (o *ShipCargo) SetUnits(v int32) {
	o.Units = v
}

// GetInventory returns the Inventory field value
func (o *ShipCargo) GetInventory() []ShipCargoItem {
	if o == nil {
		var ret []ShipCargoItem
		return ret
	}

	return o.Inventory
}

// GetInventoryOk returns a tuple with the Inventory field value
// and a boolean to check if the value has been set.
func (o *ShipCargo) GetInventoryOk() ([]ShipCargoItem, bool) {
	if o == nil {
		return nil, false
	}
	return o.Inventory, true
}

// SetInventory sets field value
func (o *ShipCargo) SetInventory(v []ShipCargoItem) {
	o.Inventory = v
}

func (o ShipCargo) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ShipCargo) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["capacity"] = o.Capacity
	toSerialize["units"] = o.Units
	toSerialize["inventory"] = o.Inventory

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *ShipCargo) UnmarshalJSON(bytes []byte) (err error) {
	varShipCargo := _ShipCargo{}

	if err = json.Unmarshal(bytes, &varShipCargo); err == nil {
		*o = ShipCargo(varShipCargo)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "capacity")
		delete(additionalProperties, "units")
		delete(additionalProperties, "inventory")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableShipCargo struct {
	value *ShipCargo
	isSet bool
}

func (v NullableShipCargo) Get() *ShipCargo {
	return v.value
}

func (v *NullableShipCargo) Set(val *ShipCargo) {
	v.value = val
	v.isSet = true
}

func (v NullableShipCargo) IsSet() bool {
	return v.isSet
}

func (v *NullableShipCargo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableShipCargo(val *ShipCargo) *NullableShipCargo {
	return &NullableShipCargo{value: val, isSet: true}
}

func (v NullableShipCargo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableShipCargo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


