/*
SpaceTraders API

SpaceTraders is an open-universe game and learning platform that offers a set of HTTP endpoints to control a fleet of ships and explore a multiplayer universe.  The API is documented using [OpenAPI](https://github.com/SpaceTradersAPI/api-docs). You can send your first request right here in your browser to check the status of the game server.  ```json http {   \"method\": \"GET\",   \"url\": \"https://api.spacetraders.io/v2\", } ```  Unlike a traditional game, SpaceTraders does not have a first-party client or app to play the game. Instead, you can use the API to build your own client, write a script to automate your ships, or try an app built by the community.  We have a [Discord channel](https://discord.com/invite/jh6zurdWk5) where you can share your projects, ask questions, and get help from other players.   

API version: 2.0.0
Contact: joel@spacetraders.io
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package spacetraders

import (
	"encoding/json"
)

// checks if the ShipRefine200ResponseDataProducedInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ShipRefine200ResponseDataProducedInner{}

// ShipRefine200ResponseDataProducedInner struct for ShipRefine200ResponseDataProducedInner
type ShipRefine200ResponseDataProducedInner struct {
	TradeSymbol *string `json:"tradeSymbol,omitempty"`
	Units *int32 `json:"units,omitempty"`
	AdditionalProperties map[string]interface{}
}

type _ShipRefine200ResponseDataProducedInner ShipRefine200ResponseDataProducedInner

// NewShipRefine200ResponseDataProducedInner instantiates a new ShipRefine200ResponseDataProducedInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewShipRefine200ResponseDataProducedInner() *ShipRefine200ResponseDataProducedInner {
	this := ShipRefine200ResponseDataProducedInner{}
	return &this
}

// NewShipRefine200ResponseDataProducedInnerWithDefaults instantiates a new ShipRefine200ResponseDataProducedInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewShipRefine200ResponseDataProducedInnerWithDefaults() *ShipRefine200ResponseDataProducedInner {
	this := ShipRefine200ResponseDataProducedInner{}
	return &this
}

// GetTradeSymbol returns the TradeSymbol field value if set, zero value otherwise.
func (o *ShipRefine200ResponseDataProducedInner) GetTradeSymbol() string {
	if o == nil || isNil(o.TradeSymbol) {
		var ret string
		return ret
	}
	return *o.TradeSymbol
}

// GetTradeSymbolOk returns a tuple with the TradeSymbol field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ShipRefine200ResponseDataProducedInner) GetTradeSymbolOk() (*string, bool) {
	if o == nil || isNil(o.TradeSymbol) {
		return nil, false
	}
	return o.TradeSymbol, true
}

// HasTradeSymbol returns a boolean if a field has been set.
func (o *ShipRefine200ResponseDataProducedInner) HasTradeSymbol() bool {
	if o != nil && !isNil(o.TradeSymbol) {
		return true
	}

	return false
}

// SetTradeSymbol gets a reference to the given string and assigns it to the TradeSymbol field.
func (o *ShipRefine200ResponseDataProducedInner) SetTradeSymbol(v string) {
	o.TradeSymbol = &v
}

// GetUnits returns the Units field value if set, zero value otherwise.
func (o *ShipRefine200ResponseDataProducedInner) GetUnits() int32 {
	if o == nil || isNil(o.Units) {
		var ret int32
		return ret
	}
	return *o.Units
}

// GetUnitsOk returns a tuple with the Units field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ShipRefine200ResponseDataProducedInner) GetUnitsOk() (*int32, bool) {
	if o == nil || isNil(o.Units) {
		return nil, false
	}
	return o.Units, true
}

// HasUnits returns a boolean if a field has been set.
func (o *ShipRefine200ResponseDataProducedInner) HasUnits() bool {
	if o != nil && !isNil(o.Units) {
		return true
	}

	return false
}

// SetUnits gets a reference to the given int32 and assigns it to the Units field.
func (o *ShipRefine200ResponseDataProducedInner) SetUnits(v int32) {
	o.Units = &v
}

func (o ShipRefine200ResponseDataProducedInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ShipRefine200ResponseDataProducedInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !isNil(o.TradeSymbol) {
		toSerialize["tradeSymbol"] = o.TradeSymbol
	}
	if !isNil(o.Units) {
		toSerialize["units"] = o.Units
	}

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *ShipRefine200ResponseDataProducedInner) UnmarshalJSON(bytes []byte) (err error) {
	varShipRefine200ResponseDataProducedInner := _ShipRefine200ResponseDataProducedInner{}

	if err = json.Unmarshal(bytes, &varShipRefine200ResponseDataProducedInner); err == nil {
		*o = ShipRefine200ResponseDataProducedInner(varShipRefine200ResponseDataProducedInner)
	}

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "tradeSymbol")
		delete(additionalProperties, "units")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableShipRefine200ResponseDataProducedInner struct {
	value *ShipRefine200ResponseDataProducedInner
	isSet bool
}

func (v NullableShipRefine200ResponseDataProducedInner) Get() *ShipRefine200ResponseDataProducedInner {
	return v.value
}

func (v *NullableShipRefine200ResponseDataProducedInner) Set(val *ShipRefine200ResponseDataProducedInner) {
	v.value = val
	v.isSet = true
}

func (v NullableShipRefine200ResponseDataProducedInner) IsSet() bool {
	return v.isSet
}

func (v *NullableShipRefine200ResponseDataProducedInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableShipRefine200ResponseDataProducedInner(val *ShipRefine200ResponseDataProducedInner) *NullableShipRefine200ResponseDataProducedInner {
	return &NullableShipRefine200ResponseDataProducedInner{value: val, isSet: true}
}

func (v NullableShipRefine200ResponseDataProducedInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableShipRefine200ResponseDataProducedInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


